//+------------------------------------------------------------------+
//|                                               SSB Oscillator.mq4 |
//+------------------------------------------------------------------+
#property  copyright ""
#property  link      ""
//---- indicator settings
#property  indicator_separate_window
#property indicator_minimum -13 // 
#property indicator_maximum 13 // 
#property  indicator_buffers 2
#property  indicator_color1  Red
#property  indicator_width1  3
#property  indicator_color2  Blue
#property  indicator_width2  3
#property indicator_level1 12 //=-1
#property indicator_level2 -12 //+1
#property indicator_levelcolor Yellow
//---- indicator parameters
extern int  dcandle=1;//-1  >0, 1  <0   
extern int  drsi=1;
extern int  dcci=1;
extern int  dac=1;
extern int  dac1=0;
extern int  dao=0;
extern int  dao1=0;
extern int  dmacd=0;
extern int  dmacd1=1;
extern int  dosma=1;
extern int  dosma1=1;
extern int  dmomentum=0;
extern int  dichimoku=1;
extern int  dema=0;
extern int  dema1=1;
extern int  dlwma=0;
extern int  dlwma1=0;
extern int  dsmma=-1;
extern int  dsmma1=-1;
extern int  dstoch=-1;
extern int  dstoch1=0;
extern int  dstoch2=-1;
//--------------------------------------
extern int  prsi=34;// 
extern int  pcci=74;
extern int  fastmacd=20;
extern int  slowmacd=51;
extern int  signalmacd=7;
extern int  pmomentum=999;
extern int  stochD=28;
extern int  stochK=38;
extern int  stochS=60;
extern int  pema=35;
extern int  plwma=999;
extern int  psmma=72;
extern int  ptenkan=83;
//---- indicator buffers
double     OscBufferBuy[];
double     OscBufferSell[]; 
  
int init()
  {

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   
   SetIndexDrawBegin(0,100);
   IndicatorDigits(Digits+1);

   SetIndexBuffer(0,OscBufferBuy);
   SetIndexBuffer(1,OscBufferSell);   
   IndicatorShortName("SSB OSCILLATOR");

   return(0);
  }

int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   
int  fcandle;
int  frsi;
int  fcci;
int  fac;
int  fac1;
int  fao;
int  fao1;
int  fmacd;
int  fmacd1;
int  fosma;
int  fosma1;
int  fmomentum;
int  fichimoku;
int  fema;
int  fema1;
int  flwma;
int  flwma1;
int  fsmma;
int  fsmma1;
int  fstoch;
int  fstoch1;
int  fstoch2;

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i=0; i<limit; i++)
   {
     OscBufferBuy[i]=0;
     OscBufferSell[i]=0;
   }

//  
   for(i=0; i<limit; i++)
   {   
   double open0=iOpen(NULL,0,i);
   double open1=iOpen(NULL,0,i+1);  
   double rsi=iRSI(NULL,0,prsi,PRICE_OPEN,i)-50.0;
   double cci=iCCI(NULL,0,pcci,PRICE_OPEN,i);       
   double ac0=iAC(NULL,0,i);
   double ac1=iAC(NULL,0,i+1);
   double ao0=iAO(NULL,0,i);
   double ao1=iAO(NULL,0,i+1);
   double macd0=iMACD(NULL,0,fastmacd,slowmacd,signalmacd,PRICE_OPEN,MODE_MAIN,i);
   double macd1=iMACD(NULL,0,fastmacd,slowmacd,signalmacd,PRICE_OPEN,MODE_MAIN,i+1);
   double osma0=iOsMA(NULL,0,fastmacd,slowmacd,signalmacd,PRICE_OPEN,i);
   double osma1=iOsMA(NULL,0,fastmacd,slowmacd,signalmacd,PRICE_OPEN,i+1);   
   double openm=iOpen(NULL,0,pmomentum+i); 
   double ema0=iMA(NULL,0,pema,0,MODE_EMA,PRICE_OPEN,i);
   double ema1=iMA(NULL,0,pema,0,MODE_EMA,PRICE_OPEN,i+1);
   double ich=iIchimoku(NULL,0,ptenkan,83,28,MODE_TENKANSEN,i);
   double wma0=iMA(NULL,0,plwma,0,MODE_LWMA,PRICE_OPEN,i);
   double wma1=iMA(NULL,0,plwma,0,MODE_LWMA,PRICE_OPEN,i+1); 
   double smma0=iMA(NULL,0,psmma,0,MODE_SMMA,PRICE_OPEN,i);
   double smma1=iMA(NULL,0,psmma,0,MODE_SMMA,PRICE_OPEN,i+1);
   double stoch_signal=iStochastic(NULL,0,stochK,stochD,stochS,MODE_SMMA,0,MODE_SIGNAL,i);
   double stoch_main=iStochastic(NULL,0,stochK,stochD,stochS,MODE_SMMA,0,MODE_MAIN,i);
   double stoch50_main=iStochastic(NULL,0,stochK,stochD,stochS,MODE_SMMA,0,MODE_MAIN,i)-50.0;
   double stoch50_signal=iStochastic(NULL,0,stochK,stochD,stochS,MODE_SMMA,0,MODE_SIGNAL,i)-50.0;   
   
if (dcandle==0)fcandle=0;
else{
if (open0>open1)fcandle=1;
if (open0<open1)fcandle=-1;
if (dcandle==1)fcandle=-fcandle;
}   
if (drsi==0)frsi=0;
else{
if (rsi>0)frsi=1;
if (rsi<0)frsi=-1;
if (drsi==1)frsi=-frsi;
}
if (dcci==0)fcci=0;
else{
if (cci>0)fcci=1;
if (cci<0)fcci=-1;
if (dcci==1)fcci=-fcci;
}
if (dac==0)fac=0;
else{
if (ac0>0)fac=1;
if (ac0<0)fac=-1;
if (dac==1)fac=-fac;
}
if (dac1==0)fac1=0;
else{
if (ac0-ac1>0)fac1=1;
if (ac0-ac1<0)fac1=-1;
if (dac1==1)fac1=-fac1;
}
if (dao==0)fao=0;
else{
if (ao0>0)fao=1;
if (ao0<0)fao=-1;
if (dao==1)fao=-fao;
}
if (dao1==0)fao1=0;
else{
if (ao0-ao1>0)fao1=1;
if (ao0-ao1<0)fao1=-1;
if (dao1==1)fao1=-fao1;
}
if (dmacd==0)fmacd=0;
else{
if (macd0>0)fmacd=1;
if (macd0<0)fmacd=-1;
if (dmacd==1)fmacd=-fmacd;
}
if (dmacd1==0)fmacd1=0;
else{
if (macd0-macd1>0)fmacd1=1;
if (macd0-macd1<0)fmacd1=-1;
if (dmacd1==1)fmacd1=-fmacd1;
}
if (dosma==0)fosma=0;
else{
if (osma0>0)fosma=1;
if (osma0<0)fosma=-1;
if (dosma==1)fosma=-fosma;
}
if (dosma1==0)fosma1=0;
else{
if (osma0-osma1>0)fosma1=1;
if (osma0-osma1<0)fosma1=-1;
if (dosma1==1)fosma1=-fosma1;
}
if (dmomentum==0)fmomentum=0;
else{
if (open0-openm>0)fmomentum=1;
if (open0-openm<0)fmomentum=-1;
if (dmomentum==1)fmomentum=-fmomentum;
}
if (dema==0)fema=0;
else{
if (open0-ema0>0)fema=1;
if (open0-ema0<0)fema=-1;
if (dema==1)fema=-fema;
}
if (dema1==0)fema1=0;
else{
if (ema0-ema1>0)fema1=1;
if (ema0-ema1<0)fema1=-1;
if (dema1==1)fema1=-fema1;
}
if (dichimoku==0)fichimoku=0;
else{
if (open0-ich>0)fichimoku=1;
if (open0-ich<0)fichimoku=-1;
if (dichimoku==1)fichimoku=-fichimoku;
}
if (dlwma==0)flwma=0;
else{
if (open0-wma0>0)flwma=1;
if (open0-wma0<0)flwma=-1;
if (dlwma==1)flwma=-flwma;
}
if (dlwma1==0)flwma1=0;
else{
if (wma0-wma1>0)flwma1=1;
if (wma0-wma1<0)flwma1=-1;
if (dlwma1==1)flwma1=-flwma1;
}
if (dsmma==0)fsmma=0;
else{
if (open0-smma0>0)fsmma=1;
if (open0-smma0<0)fsmma=-1;
if (dsmma==1)fsmma=-fsmma;
}
if (dsmma1==0)fsmma1=0;
else{
if (smma0-smma1>0)fsmma1=1;
if (smma0-smma1<0)fsmma1=-1;
if (dsmma1==1)fsmma1=-fsmma1;
}
if (dstoch==0)fstoch=0;
else{
if (stoch_signal-stoch_main>0)fstoch=1;
if (stoch_signal-stoch_main<0)fstoch=-1;
if (dstoch==1)fstoch=-fstoch;  
}
if (dstoch1==0)fstoch1=0;
else{
if (stoch50_main>0)fstoch1=1;
if (stoch50_main<0)fstoch1=-1;
if (dstoch1==1)fstoch1=-fstoch1; 
}
if (dstoch2==0)fstoch2=0;
else{
if (stoch50_signal>0)fstoch2=1;
if (stoch50_signal<0)fstoch2=-1;
if (dstoch2==1)fstoch2=-fstoch2; 
}
    if (fcandle>0)OscBufferBuy[i]=OscBufferBuy[i]+fcandle;
    if (frsi>0)OscBufferBuy[i]=OscBufferBuy[i]+frsi;
    if (fcci>0)OscBufferBuy[i]=OscBufferBuy[i]+fcci;
    if (fac>0)OscBufferBuy[i]=OscBufferBuy[i]+fac;
    if (fac1>0)OscBufferBuy[i]=OscBufferBuy[i]+fac1;
    if (fao>0)OscBufferBuy[i]=OscBufferBuy[i]+fao;
    if (fao1>0)OscBufferBuy[i]=OscBufferBuy[i]+fao1;    
    if (fmacd>0)OscBufferBuy[i]=OscBufferBuy[i]+fmacd;
    if (fmacd1>0)OscBufferBuy[i]=OscBufferBuy[i]+fmacd1;
    if (fosma>0)OscBufferBuy[i]=OscBufferBuy[i]+fosma;
    if (fosma1>0)OscBufferBuy[i]=OscBufferBuy[i]+fosma1; 
    if (fmomentum>0)OscBufferBuy[i]=OscBufferBuy[i]+fmomentum; 
    if (fema>0)OscBufferBuy[i]=OscBufferBuy[i]+fema;    
    if (fema1>0)OscBufferBuy[i]=OscBufferBuy[i]+fema1;
    if (fichimoku>0)OscBufferBuy[i]=OscBufferBuy[i]+fichimoku;
    if (flwma>0)OscBufferBuy[i]=OscBufferBuy[i]+flwma;
    if (flwma1>0)OscBufferBuy[i]=OscBufferBuy[i]+flwma1;
    if (fsmma>0)OscBufferBuy[i]=OscBufferBuy[i]+fsmma;
    if (fsmma1>0)OscBufferBuy[i]=OscBufferBuy[i]+fsmma1;
    if (fstoch>0)OscBufferBuy[i]=OscBufferBuy[i]+fstoch;
    if (fstoch1>0)OscBufferBuy[i]=OscBufferBuy[i]+fstoch1;
    if (fstoch2>0)OscBufferBuy[i]=OscBufferBuy[i]+fstoch2;        

    if (fcandle<0)OscBufferSell[i]=OscBufferSell[i]+fcandle;
    if (frsi<0)OscBufferSell[i]=OscBufferSell[i]+frsi;
    if (fcci<0)OscBufferSell[i]=OscBufferSell[i]+fcci;
    if (fac<0)OscBufferSell[i]=OscBufferSell[i]+fac;
    if (fac1<0)OscBufferSell[i]=OscBufferSell[i]+fac1;
    if (fao<0)OscBufferSell[i]=OscBufferSell[i]+fao;
    if (fao1<0)OscBufferSell[i]=OscBufferSell[i]+fao1;    
    if (fmacd<0)OscBufferSell[i]=OscBufferSell[i]+fmacd;
    if (fmacd1<0)OscBufferSell[i]=OscBufferSell[i]+fmacd1;
    if (fosma<0)OscBufferSell[i]=OscBufferSell[i]+fosma;
    if (fosma1<0)OscBufferSell[i]=OscBufferSell[i]+fosma1; 
    if (fmomentum<0)OscBufferSell[i]=OscBufferSell[i]+fmomentum; 
    if (fema<0)OscBufferSell[i]=OscBufferSell[i]+fema;    
    if (fema1<0)OscBufferSell[i]=OscBufferSell[i]+fema1;
    if (fichimoku<0)OscBufferSell[i]=OscBufferSell[i]+fichimoku;
    if (flwma<0)OscBufferSell[i]=OscBufferSell[i]+flwma;
    if (flwma1<0)OscBufferSell[i]=OscBufferSell[i]+flwma1;
    if (fsmma<0)OscBufferSell[i]=OscBufferSell[i]+fsmma;
    if (fsmma1<0)OscBufferSell[i]=OscBufferSell[i]+fsmma1;
    if (fstoch<0)OscBufferSell[i]=OscBufferSell[i]+fstoch;
    if (fstoch1<0)OscBufferSell[i]=OscBufferSell[i]+fstoch1;
    if (fstoch2<0)OscBufferSell[i]=OscBufferSell[i]+fstoch2;    
   }
   return(0);
  }
//+---------------------------------------------------------------